﻿using System.Collections.Generic;
using Newtonsoft.Json;

namespace Google.API.Predict.Requests.Features
{
    /// <summary>
    /// Holds numeric features
    /// Generalized for various numeric types
    /// Used to fully mimic prediction feature structure for simplified JSON deserialization
    /// </summary>
    public class NumericFeatureData<TFeatureType>
    {
        /// <summary>
        /// Default Constructor
        /// </summary>
        public NumericFeatureData()
        {
            Content = new List<TFeatureType>();
        }

        /// <summary>
        /// Goal: "numeric" : [ 1, 10, 0 ] }}}
        /// </summary>
        [JsonProperty("numeric")]
        public List<TFeatureType> Content { get; set; }
    }
}