
namespace Google.API.Predict.Requests.Features
{
    /// <summary>
    /// Numeric prediction feature holder
    /// </summary>
    public sealed class NumericFeatures<TNumeric> : FeatureData<NumericFeatureData<TNumeric>>, IFeature
    {
        /// <summary>
        /// Default Constructor
        /// </summary>
        /// <param name="features">features to send with prediction request</param>
        public NumericFeatures(params TNumeric[] features)
        {
            Content.Content.Content.AddRange(features);
        }
    }
}
