﻿// ***********************************************************************
// Assembly         : GooglePredict
// Author           : aj
// Created          : 10-08-2010
//
// Last Modified By : aj
// Last Modified On : 10-08-2010
// Description      : 
//
//
// ***********************************************************************
namespace Google.API.Predict.Requests.Core
{
    /// <summary>
    /// Represents commonality among all prediction api requests
    /// </summary>
    public interface IGooglePredictionApiRequest
    {
        /// <summary>
        /// Gets or sets Authentication token used to access Prediction API
        /// Retrieved from ClientLogin
        /// </summary>
        string Auth { get; set; }

        /// <summary>
        /// Gets or sets Name of Google Storage "Bucket"
        /// Buckets are the basic containers that hold your data.
        /// Everything that you store in Google Storage must be contained in a bucket.
        /// You can use buckets to organize your data and control access to your data, but unlike directories and folders, you cannot nest buckets.
        /// </summary>
        string Bucket { get; set; }

        /// <summary>
        /// Gets or sets Name of Google Storage "Object Data"
        /// The object data component is usually a file that you want to store in Google Storage.
        /// </summary>
        string Data { get; set; }
    }
}
