﻿using Newtonsoft.Json;

namespace Google.API.Predict.Requests.Features
{
    /// <summary>
    /// Used to fully mimic prediction feature structure for simplified JSON deserialization
    /// </summary>
    /// <typeparam name="TFeatureType">Numeric, Text, Mixed</typeparam>
    public class FeatureData<TFeatureType> where TFeatureType : new()
    {
        /// <summary>
        /// Default Constructor
        /// </summary>
        public FeatureData()
        {
            Content = new FeatureInput<TFeatureType>();
        }

        /// <summary>
        /// Goal: {"data":{
        /// </summary>
        [JsonProperty("data")]
        public FeatureInput<TFeatureType> Content { get; set; }
    }
}