namespace Google.API.Predict.Requests.Features
{
    using Newtonsoft.Json;

    /// <summary>
    /// Used to fully mimic prediction feature structure for simplified JSON deserialization
    /// </summary>
    /// <typeparam name="TFeatureType">Numeric, Text, Mixed</typeparam>
    public class FeatureInput<TFeatureType> where TFeatureType : new()
    {
        /// <summary>
        /// Default Constructor
        /// </summary>
        public FeatureInput()
        {
            Content = new TFeatureType();
        }

        /// <summary>
        /// Goal: "input" : { 
        /// </summary>
        [JsonProperty("input")]
        public TFeatureType Content { get; set; }
    }
}
