﻿// ***********************************************************************
// Assembly         : GooglePredict
// Author           : aj
// Created          : 10-08-2010
//
// Last Modified By : aj
// Last Modified On : 10-08-2010
// Description      : 
//
//
// ***********************************************************************

// A little clever here, maybe too clever - goal was to uncouple prediction features from Json.NET
// {"data":{ 
//  "input" : { 
//    "text" : [ "myinput" ] }}}
// http://code.google.com/apis/predict/docs/developer-guide.html#predict
namespace Google.API.Predict.Requests.Features
{
    using System.Collections.Generic;
    using Newtonsoft.Json;

    /// <summary>
    /// Holds Mixed features
    /// Used to fully mimic prediction feature structure for simplified JSON deserialization
    /// </summary>
    public class MixedFeatureData
    {
        /// <summary>
        /// Default Constructor
        /// </summary>
        public MixedFeatureData()
        {
            Content = new List<object>();
        }

        /// <summary>
        /// Goal: "mixture" : [ "text", 10, 0 ] }}}
        /// </summary>
        [JsonProperty("mixture")]
        public List<object> Content { get; set; }
    }

}
