﻿using System.Collections.Generic;
using Newtonsoft.Json;

namespace Google.API.Predict.Requests.Features
{
    /// <summary>
    /// Holds Text features
    /// Used to fully mimic prediction feature structure for simplified JSON deserialization
    /// </summary>
    public class TextFeatureData
    {
        /// <summary>
        /// Default Constructor
        /// </summary>
        public TextFeatureData()
        {
            Content = new List<string>();
        }

        /// <summary>
        /// Goal: "text" : [ "myinput" ] }}}
        /// </summary>
        [JsonProperty("text")]
        public List<string> Content { get; set; }
    }
}