﻿// ***********************************************************************
// Assembly         : GooglePredict
// Author           : aj
// Created          : 10-08-2010
//
// Last Modified By : aj
// Last Modified On : 10-08-2010
// Description      : 
//
//
// ***********************************************************************
namespace Google.API.Predict.Responses
{
    using Newtonsoft.Json;

    /// <summary>
    /// Used to serialize "Check Training" response JSON objects
    /// </summary>
    [JsonObject(MemberSerialization = MemberSerialization.OptOut)]
    public class MetadataResponse : BaseResponse
    {
        /// <summary>
        /// Data Field - usually "bucket/data"
        /// </summary>
        [JsonProperty("data")]
        public string Data { get; set; }

        /// <summary>
        /// Gets or Sets Model Info
        /// Confirms if a model is finished training and returns the accuracy
        /// </summary>
        [JsonProperty("modelinfo")]
        public string ModelInfo { get; set; }

        /// <summary>
        /// Determined by the request based on the ModelInfo data
        /// </summary>
        [JsonIgnore]
        public bool TrainingComplete { get; set; }
    }
}
