﻿// ***********************************************************************
// Assembly         : GooglePredict
// Author           : aj
// Created          : 10-08-2010
//
// Last Modified By : aj
// Last Modified On : 10-08-2010
// Description      : 
//
//
// ***********************************************************************
namespace Google.API.Predict.Responses
{
    using Newtonsoft.Json;

    /// <summary>
    /// Used to serialize Training request response JSON objects
    /// http://code.google.com/apis/predict/docs/developer-guide.html#invoke-training
    /// </summary>
    [JsonObject(MemberSerialization = MemberSerialization.OptOut)]
    public class TrainingResponse : BaseResponse
    {
        /// <summary>
        /// If the value is the same as the bucket/data this indicates training has
        /// started successfully
        /// </summary>
        [JsonProperty("data")]
        public string Data { get; set; }

        /// <summary>
        /// Indicates if training was invoked
        /// </summary>
        [JsonIgnore]
        public bool TrainingInvoked
        {
            get;
            set;
        }
    }
}
